#pragma once

#include <windows.h>

class CLogFont
{
private:
	LOGFONT m_lf;

public:

	CLogFont(void)
	{
		::ZeroMemory(&m_lf, sizeof(m_lf));
	}

	CLogFont(const LOGFONT &lf) {
		::CopyMemory(&m_lf, &lf, sizeof(m_lf));
	}

	CLogFont(const CLogFont &ob) {
		::CopyMemory(&m_lf, &(ob.m_lf), sizeof(m_lf));
	}

	CLogFont(const CFont &font) {
		CFont *pFont = const_cast<CFont *>(&font);
		pFont->GetLogFont(&m_lf);
	}

	~CLogFont(void)
	{
	}

	const CLogFont &operator =(const LOGFONT &lf) {
		::CopyMemory(&m_lf, &lf, sizeof(m_lf));
		return *this;
	}

	const CLogFont &operator =(const CLogFont &ob) {
		::CopyMemory(&m_lf, &(ob.m_lf), sizeof(m_lf));
		return *this;
	}

	const CLogFont &operator =(const CFont &font) {
		CFont *pFont = const_cast<CFont *>(&font);
		pFont->GetLogFont(&m_lf);
		return *this;
	}

	LOGFONT *GetLogFont(void) {
		return &m_lf;
	}

	const LOGFONT *GetLogFont(void) const {
		return &m_lf;
	}

	void SetBold(BOOL isBold) {
		m_lf.lfWeight = isBold ? FW_HEAVY : FW_NORMAL;
	}

	BOOL GetBold(void) const {
		return (m_lf.lfWeight == FW_HEAVY);
	}

	void SetItalic(BOOL isItalic) {
		m_lf.lfItalic = isItalic;
	}

	BOOL GetItalic(void) const {
		return m_lf.lfItalic;
	}
};
